﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.load {
    import flash.events.*;
    import flash.display.*;
    import flash.net.*;

    public class DisplayLoader extends Sprite {

        private var loader:Loader;
        private var list:XMLList;
        private var index:int = 0;

        public function DisplayLoader(_arg1:XMLList):void{
            this.list = _arg1;
            this.load(_arg1[this.index]);
        }
        public function load(_arg1:String):void{
            this.loader = new Loader();
            this.loader.load(new URLRequest(_arg1));
            this.loader.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, this.progressHandler);
            this.loader.contentLoaderInfo.addEventListener(Event.COMPLETE, this.completeHandler);
            this.loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler);
        }
        private function progressHandler(_arg1:ProgressEvent):void{
            this.dispatchEvent(new Event(ProgressEvent.PROGRESS));
        }
        private function ioErrorHandler(_arg1:IOErrorEvent):void{
            this.loader.removeEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler);
            this.next();
        }
        private function completeHandler(_arg1:Event):void{
            this.loader.contentLoaderInfo.removeEventListener(Event.COMPLETE, this.completeHandler);
            addChild(this.loader);
            this.next();
        }
        private function next():void{
            if (this.index < (this.list.length() - 1)){
                this.index++;
                this.load(this.list[this.index]);
            } else {
                this.dispatchEvent(new Event(Event.COMPLETE));
            };
        }
        public function get percent():Number{
            return (Math.round(((this.loader.contentLoaderInfo.bytesLoaded / this.loader.contentLoaderInfo.bytesTotal) * 100)));
        }

    }
}//package com.load 
