﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.lyrics {
    import flash.events.*;
    import caurina.transitions.*;
    import flash.display.*;
    import flash.utils.*;
    import flash.text.*;
    import flash.net.*;
    import flash.system.*;

    public class PlayLyrics extends Sprite {

        private var loader:URLLoader;
        private var container:Sprite;
        private var lyricsContainer:Sprite;
        private var centerLine:Sprite;
        private var lyricsList:Array;
        private var textFormat_show:TextFormat;
        private var textFormat_default:TextFormat;
        private var textFormat:TextFormat;
        private var index:int = 0;
        private var _timer:Timer;
        private var _mask:Sprite;
        private var _paused:Boolean;
        private var _loaded:Boolean;
        private var _player:Object;
        private var _beginTime:Number;
        private var _totalTime:Number;
        private var _percent:Number;
        private var seekText:TextField;
        private var setWidth:Number;

        public function PlayLyrics(_arg1:Object, _arg2:Number=150, _arg3:Number=150):void{
            this.textFormat_show = new TextFormat("Arial", 12, 0xFFFF00 );
            this.textFormat_default = new TextFormat("Arial", 12, 0xFF00FF);
            this.textFormat = new TextFormat("宋体", 12, 0xFF00FF);
            super();
            System.useCodePage = true;
            this._player = _arg1;
            this.setWidth = _arg2;
            this.onResize(_arg2, _arg3);
            this._timer = new Timer(100);
            this._timer.addEventListener(TimerEvent.TIMER, this.onTimerHandler);
        }
        public function load(_arg1:String):void{
            this.clear();
            this._loaded = false;
            this._paused = false;
            this.loader = new URLLoader();
            this.loader.load(new URLRequest(_arg1));
            this.loader.addEventListener(Event.COMPLETE, this.completeHandler);
            this.loader.addEventListener(IOErrorEvent.IO_ERROR, this.ioerrorHandler);
        }
        private function completeHandler(_arg1:Event):void{
            this._loaded = true;
            this.loader.removeEventListener(Event.COMPLETE, this.completeHandler);
            this.lyricsList = DecodeLyrics.decode(_arg1.target.data);
            this.initText();
            this._timer.start();
        }
        private function ioerrorHandler(_arg1:IOErrorEvent):void{
            trace("暂没有歌词");
        }
        private function onResize(_arg1:Number, _arg2:Number):void{
            this.lyricsContainer = new Sprite();
            this.container = new Sprite();
            addChild(this.container);
            this.container.addChild(this.lyricsContainer);
            this.container.y = (_arg2 / 2);
            this._mask = new Sprite();
            this._mask.graphics.beginFill(0);
            this._mask.graphics.drawRect(0, 18, _arg1, _arg2);
            this._mask.graphics.endFill();
            addChild(this._mask);
            this.container.mask = this._mask;
            this.centerLine = new Sprite();
            this.centerLine.graphics.lineStyle(1, 0x999999, 1);
            this.centerLine.graphics.moveTo((this.container.x + 360), (this.container.y - 6));
            this.centerLine.graphics.lineTo((this.container.x + 360), (this.container.y + 6));
            this.centerLine.graphics.moveTo((this.container.x + 360), this.container.y);
            this.centerLine.graphics.lineTo((_arg1 - 360), this.container.y);
            this.centerLine.graphics.moveTo((_arg1 - 360), (this.container.y - 6));
            this.centerLine.graphics.lineTo((_arg1 - 360), (this.container.y + 6));
            addChild(this.centerLine);
            this.seekText = this.textField(this.textFormat_default, "00:00");
            addChild(this.seekText);
            this.seekText.x = (_arg1 - 375);
            (_arg1 - this.seekText.width);
            this.seekText.y = (this.container.y + 2);
            this.centerLine.visible = false;
            this.seekText.visible = false;
        }
        private function initText():void{
            var _local2:TextField;
            var _local1:* = 0;
            while (_local1 < this.lyricsList.length) {
                _local2 = this.textField(this.textFormat_default, this.lyricsList[_local1].lrc.toString());
                _local2.name = ("txt" + _local1);
                _local2.y = this.lyricsContainer.height;
                _local2.x = ((this.setWidth - _local2.width) / 2);
                this.lyricsContainer.addChild(_local2);
                _local1++;
            };
            this.state(this.index);
        }
        public function state(_arg1:int):void{
            var _local3:TextField;
            var _local2:* = 0;
            while (_local2 < this.lyricsList.length) {
                _local3 = (this.lyricsContainer.getChildByName(("txt" + _local2)) as TextField);
                if ((_local2 == _arg1)){
                    _local3.setTextFormat(this.textFormat_show);
                } else {
                    _local3.setTextFormat(this.textFormat_default);
                };
                _local2++;
            };
        }
        private function onTimerHandler(_arg1:TimerEvent):void{
            var _local2:Number;
            var _local3:Number;
            if ((((this._player.position > 0)) && ((this._player.position <= this._player.length)))){
                if (this._player.position >= this.lyricsList[this.index].time){
                    this.state(this.index);
                    _local2 = -((this.lyricsContainer.getChildByName(("txt" + this.index)).y + this.lyricsContainer.getChildByName(("txt" + this.index)).height));
                    _local3 = 0.3;
                    if (this.index != (this.lyricsList.length - 1)){
                        this.index++;
                    } else {
                        this.index = (this.lyricsList.length - 1);
                    };
                    Tweener.addTween(this.lyricsContainer, {
                        y:_local2,
                        time:_local3,
                        transition:"easeNone"
                    });
                };
            };
        }
        public function pause():void{
            Tweener.pauseTweens(this.lyricsContainer);
            this._timer.stop();
            this._paused = true;
        }
        public function resume():void{
            if (this._paused){
                Tweener.resumeTweens(this.lyricsContainer);
            };
            this._paused = false;
            this._timer.start();
        }
        public function stop():void{
            this.clear();
            this.initText();
        }
        public function clear():void{
            if (this._timer){
                this._timer.stop();
                Tweener.removeTweens(this.lyricsContainer);
            };
            this.index = 0;
            this.lyricsContainer.y = 0;
            if (this.loader){
                try {
                    this.loader.close();
                } catch(event:Error) {
                };
                this.loader = null;
            };
            while (this.lyricsContainer.numChildren > 0) {
                this.lyricsContainer.removeChildAt(0);
            };
        }
        public function seek(_arg1:Number):void{
            var _local2:int;
            if (this._loaded){
                Tweener.removeTweens(this.lyricsContainer);
                _local2 = 1;
                while (_local2 < this.lyricsList.length) {
                    if ((((_arg1 >= this.lyricsList[(_local2 - 1)].time)) && ((_arg1 <= this.lyricsList[_local2].time)))){
                        this.index = (_local2 - 1);
                        this._beginTime = this.lyricsList[(_local2 - 1)].time;
                        this._totalTime = (this.lyricsList[_local2].time - this.lyricsList[(_local2 - 1)].time);
                        break;
                    };
                    if (_arg1 > 0){
                        this.index = (this.lyricsList.length - 1);
                        this._beginTime = this.lyricsList[(this.lyricsList.length - 1)].time;
                        this._totalTime = (this._player.length - this._beginTime);
                    } else {
                        this.index = 0;
                    };
                    _local2++;
                };
                this._percent = ((_arg1 - this._beginTime) / this._totalTime);
                this.lyricsContainer.y = -((this.lyricsContainer.getChildByName(("txt" + this.index)).y + (this.lyricsContainer.getChildByName(("txt" + this.index)).height * this._percent)));
                this.seekText.text = this.millToTime(_arg1);
                this.seekText.setTextFormat(this.textFormat);
                this.state(this.index);
            };
        }
        public function millToTime(_arg1:Number):String{
            _arg1 = (_arg1 / 1000);
            var _local2:* = int((_arg1 / 60));
            var _local3:* = int((_arg1 % 60));
            if ((_local2 < 10)){
                _local2 = ("0" + _local2);
            };
            if ((_local3 < 10)){
                _local3 = ("0" + _local3);
            };
            return (((_local2 + ":") + _local3));
        }
        public function set scrubbing(_arg1:Boolean):void{
            if (_arg1){
                this.centerLine.visible = true;
                this.seekText.visible = true;
                this._timer.stop();
            } else {
                this.centerLine.visible = false;
                this.seekText.visible = false;
                if (!this._paused){
                    this._timer.start();
                };
            };
        }
        private function textField(_arg1:TextFormat, _arg2:String):TextField{
            var _local3:TextField = new TextField();
            _local3.autoSize = TextFieldAutoSize.LEFT;
            _local3.selectable = false;
            _local3.text = _arg2;
            _local3.setTextFormat(_arg1);
            return (_local3);
        }

    }
}//package com.lyrics 
