﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.ui {
    import flash.events.*;
    import flash.display.*;
    import flash.utils.*;
    import flash.text.*;
    import com.utils.*;
    import com.lyrics.*;
    import com.vini123.spectrum.*;
    import flash.geom.*;
    import com.players.*;
    import com.Analyzer.*;

    public class LRCPlayer extends MovieClip {

        public var seekBar:MovieClip;//instance name
        public var loadBar:MovieClip;//instance name
        public var sp:Spectrum;//instance name
        public var playlistButton:MovieClip;//instance name
        public var muteButton:VolumeIcon;//instance name
        public var playheadBar:MovieClip;//instance name
        public var nextButton:SimpleButton;//instance name
        public var pauseButton:SimpleButton;//instance name
        public var seekControlBar:MovieClip;//instance name
        public var stopButton:SimpleButton;//instance name
        public var timeStatus:TextField;//instance name
        public var prevButton:SimpleButton;//instance name
        public var playStatus:TextField;//instance name
        public var volumeBar:MovieClip;//instance name
        public var volumeheadBar:MovieClip;//instance name
        public var playButton:SimpleButton;//instance name
        public var volumeControlBar:MovieClip;//instance name
        private var playUrl;
        private var lrcUrl;
        private var title;
        private var player:Player;
        private var playLyric:PlayLyrics;
        private var playlist:Playlist;
        private var analyzer:ColumnAnalyzer;
        private var progressInterval:Number;
        private var scrubbInterval:Number;
        private var scrubbing:Boolean;
        private var seekpoint:Number;
        private var mute:Boolean;
        private var thumbX:Number = 0;
        private var volume:Number = 0;
        private var open:Boolean = true;

        public function LRCPlayer(_arg1, _arg2, _arg3):void{
            addFrameScript(0, this.frame1);
            this.playUrl = _arg1;
            this.lrcUrl = _arg2;
            this.title = _arg3;
            this.init();
        }
        public function init():void{
            this.player = new Player();
            this.player.url = this.playUrl;
            this.playLyric = new PlayLyrics(this.player, this.width);
            addChild(this.playLyric);
            this.playLyric.y = -340;
            this.playLyric.x = 0;
            this.playlist = new Playlist(this.title);
            addChild(this.playlist);
            this.playlist.player = this.player;
            this.playlist.visible = false;
            this.playlist.x = 225;
            this.playlist.y = -340;
            this.analyzer = new ColumnAnalyzer();
            this.analyzer.x = ((this.width - this.analyzer.width) - 325);
            this.analyzer.y = -10;
            addChild(this.analyzer);
            this.player.addEventListener("event.play", this.playHandler);
            this.player.addEventListener("progress", this.progressHandler);
            this.player.initPlay();
            this.progressInterval = setInterval(this.progressUpdate, 30);
            this.seekBar.buttonMode = true;
            this.playlistButton.buttonMode = true;
            this.loadBar.mouseEnabled = false;
            this.playheadBar.mouseEnabled = false;
            this.status = false;
            this.playButton.addEventListener(MouseEvent.CLICK, this.playButtonClickHandler);
            this.stopButton.addEventListener(MouseEvent.CLICK, this.stopButtonClickHandler);
            this.pauseButton.addEventListener(MouseEvent.CLICK, this.pauseButtonClickHandler);
            this.nextButton.addEventListener(MouseEvent.CLICK, this.nextButtonClickHandler);
            this.prevButton.addEventListener(MouseEvent.CLICK, this.prevButtonClickHandler);
            this.playlistButton.addEventListener(MouseEvent.CLICK, this.playlistButtonClickHandler);
            this.seekBar.addEventListener(MouseEvent.MOUSE_DOWN, this.seekBarDownHandler);
            this.seekControlBar.addEventListener(MouseEvent.MOUSE_DOWN, this.seekControlBarDownHandler);
            this.volumeBar.buttonMode = true;
            this.muteButton.buttonMode = true;
            this.volumeheadBar.mouseEnabled = false;
            this.volumeBar.addEventListener(MouseEvent.MOUSE_DOWN, this.volumeBarDownHandler);
            this.volumeControlBar.addEventListener(MouseEvent.MOUSE_DOWN, this.volumeControlBarDownHandler);
            this.muteButton.addEventListener(MouseEvent.MOUSE_DOWN, this.muteButtonDownHandler);
        }
        private function playHandler(_arg1:Event):void{
			laifu = "笑看人生提示";
			qq365394947 = "  [本舞曲由Qq365394947提供]";
            this.status = false;
            this.initVolume(this.player.volume);
            this.playLyric.load(this.lrcUrl[_arg1.target.index]);
            this.playStatus.text = (laifu + ("您正在播放：" +   this.title[_arg1.target.index]) + qq365394947);
        }
        private function progressHandler(_arg1:Event):void{
            var _local2:Number = (this.player.bytesLoaded / this.player.bytesTotal);
            if ((((_local2 > 0)) && (!((_local2 == Infinity))))){
                this.loadBar.width = (this.seekBar.width + ((this.seekControlBar.width - this.seekBar.width) * _local2));
            } else {
                this.loadBar.width = this.seekBar.width;
            };
        }
        private function progressUpdate():void{
            if (this.scrubbing){
                this.timeStatus.text = ((NumberUtil.millToTime(this.seekpoint) + " / ") + NumberUtil.millToTime(this.player.duration));
            } else {
                if ((((this.player.position > 0)) && ((this.player.duration > 0)))){
                    this.seekBar.x = (((this.player.position / this.player.duration) * (this.seekControlBar.width - this.seekBar.width)) + this.seekControlBar.x);
                } else {
                    this.seekBar.x = this.seekControlBar.x;
                };
                this.timeStatus.text = ((NumberUtil.millToTime(this.player.position) + " / ") + NumberUtil.millToTime(this.player.duration));
            };
            this.playheadBar.width = (this.seekBar.x - this.seekControlBar.x);
            this.analyzer.start();
        }
        private function seekBarDownHandler(_arg1:MouseEvent=null):void{
            var _local2:Rectangle;
            if (this.player.playing){
                this.scrubbing = true;
                this.player.scrubbing = true;
                this.playLyric.scrubbing = true;
                this.scrubbInterval = setInterval(this.scrubbUpdate, 30);
                _local2 = new Rectangle(this.seekControlBar.x, this.seekBar.y, Math.round((this.loadBar.width - this.seekBar.width)));
                this.seekBar.startDrag(false, _local2);
                stage.addEventListener(MouseEvent.MOUSE_UP, this.seekBarUpHandler);
            };
        }
        private function seekBarUpHandler(_arg1:MouseEvent):void{
            stage.removeEventListener(MouseEvent.MOUSE_UP, this.seekBarUpHandler);
            this.seekBar.stopDrag();
            clearInterval(this.scrubbInterval);
            this.player.seek(this.seekpoint);
            this.playLyric.scrubbing = false;
            this.scrubbing = false;
            this.player.scrubbing = false;
        }
        function scrubbUpdate():void{
            this.seekpoint = (((this.seekBar.x - this.seekControlBar.x) / (this.seekControlBar.width - this.seekBar.width)) * this.player.duration);
            this.playLyric.seek(this.seekpoint);
        }
        private function seekControlBarDownHandler(_arg1:MouseEvent):void{
            this.seekBar.x = (mouseX - (this.seekBar.width / 2));
            if (mouseX <= (this.seekControlBar.x + this.seekBar.width)){
                this.seekBar.x = mouseX;
            };
            if (mouseX >= (this.seekControlBar.x + this.loadBar.width)){
                this.seekBar.x = (this.seekControlBar.x + (this.loadBar.width - this.seekBar.width));
            };
            this.seekBarDownHandler();
        }
        private function volumeBarDownHandler(_arg1:MouseEvent=null):void{
            var _local2:Rectangle = new Rectangle(this.volumeControlBar.x, this.volumeBar.y, (this.volumeControlBar.width - this.volumeBar.width), 0);
            this.volumeBar.startDrag(false, _local2);
            stage.addEventListener(MouseEvent.MOUSE_UP, this.volumeBarUpHandler);
            stage.addEventListener(MouseEvent.MOUSE_MOVE, this.volumeChangeHandler);
        }
        private function volumeBarUpHandler(_arg1:MouseEvent):void{
            this.volumeBar.stopDrag();
            stage.removeEventListener(MouseEvent.MOUSE_UP, this.volumeBarUpHandler);
            stage.removeEventListener(MouseEvent.MOUSE_MOVE, this.volumeChangeHandler);
        }
        private function volumeChangeHandler(_arg1:MouseEvent=null):void{
            this.volume = ((this.volumeBar.x - this.volumeControlBar.x) / (this.volumeControlBar.width - this.volumeBar.width));
            this.volumeChange(this.volume);
            this.thumbX = this.volumeBar.x;
        }
        private function volumeControlBarDownHandler(_arg1:MouseEvent):void{
            this.volumeheadBar.width = (mouseX - this.volumeheadBar.x);
            this.volumeBar.x = (mouseX - (this.volumeBar.width / 2));
            if (mouseX <= (this.volumeControlBar.x + this.volumeBar.width)){
                this.volumeBar.x = mouseX;
            };
            if (mouseX >= (this.volumeControlBar.x + this.volumeControlBar.width)){
                this.volumeBar.x = (this.volumeControlBar.x + (this.volumeControlBar.width - this.volumeBar.width));
            };
            this.volumeChangeHandler();
            this.volumeBarDownHandler();
        }
        private function muteButtonDownHandler(_arg1:MouseEvent):void{
            if (this.player.volume > 0){
                this.mute = false;
            } else {
                this.mute = true;
            };
            this.mute = !(this.mute);
            if (this.mute){
                this.volumeChange(0);
                this.volumeBar.x = this.volumeControlBar.x;
            } else {
                this.volumeChange(this.volume);
                this.volumeBar.x = this.thumbX;
            };
        }
        function volumeChange(_arg1:Number):void{
            this.player.volume = _arg1;
            this.volumeheadBar.width = (this.player.volume * this.volumeControlBar.width);
            this.muteButton.change = _arg1;
        }
        function initVolume(_arg1:Number):void{
            this.volumeBar.x = (this.volumeControlBar.x + ((this.volumeControlBar.width - this.volumeBar.width) * _arg1));
            this.volumeheadBar.width = (this.volumeControlBar.width * _arg1);
            this.volume = _arg1;
            this.thumbX = this.volumeBar.x;
            this.muteButton.change = _arg1;
        }
        private function playButtonClickHandler(_arg1:MouseEvent):void{
            this.player.resume();
            this.playLyric.resume();
            this.status = false;
        }
        private function pauseButtonClickHandler(_arg1:MouseEvent):void{
            this.player.pause();
            this.playLyric.pause();
            this.status = true;
        }
        private function stopButtonClickHandler(_arg1:MouseEvent):void{
            this.player.stop();
            this.playLyric.stop();
            this.status = true;
        }
        private function prevButtonClickHandler(_arg1:MouseEvent):void{
            this.playLyric.clear();
            this.player.prev();
        }
        private function nextButtonClickHandler(_arg1:MouseEvent):void{
            this.playLyric.clear();
            this.player.next();
        }
        private function playlistButtonClickHandler(_arg1:MouseEvent):void{
            this.open = !(this.open);
            if (this.open){
                this.playlist.visible = false;
				this.playLyric.visible = true;
            } else {
                this.playlist.visible = true;
				this.playLyric.visible = false;
            };
        }
        private function set status(_arg1:Boolean):void{
            if (_arg1){
                this.pauseButton.visible = false;
                this.playButton.visible = true;
            } else {
                this.pauseButton.visible = true;
                this.playButton.visible = false;
            };
        }
        function frame1(){
            this.sp.creatSoundFx(752, 440);
            this.sp.start();
            this.sp.x = 0;
            this.sp.y = -450;
        }

    }
}//package com.ui 
