﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.ui {
    import flash.events.*;
    import flash.display.*;
    import com.utils.*;

    public class Playlist extends Sprite {

        public static const PAGE_SIZE:int = 7;

        private var itemButton:ItemButton;
        private var item:Array;
        private var itemIndex:int = 0;
        private var itemTotal:int;
        private var pageIndex:int;
        private var currentPageIndex:int;
        private var pageTotal:int;
        private var currentPage:Array;
        private var pageTotalText:Label;
        private var startButton:Button;
        private var nextButton:Button;
        private var prevButton:Button;
        private var endButton:Button;
        private var currentPageText:Label;
        private var fengexian:Label;
        private var _player:Object;

        public function Playlist(_arg1):void{
            var _local2:int;
            var _local3:int;
            this.item = [];
            this.currentPage = [];
            super();
            if ((((_arg1 is XMLList)) || ((_arg1 is XML)))){
                _local2 = 0;
                while (_local2 < _arg1.length()) {
                    this.itemButton = new ItemButton(((this.convert((_local2 + 1)) + " . ") + _arg1[_local2]));
                    this.itemButton.name = _local2.toString();
                    this.item.push(this.itemButton);
                    this.state(this.itemIndex, true);
                    _local2++;
                };
            } else {
                if ((_arg1 is Array)){
                    _local3 = 0;
                    while (_local3 < _arg1.length) {
                        this.itemButton = new ItemButton(((this.convert((_local3 + 1)) + " . ") + _arg1[_local3]));
                        this.itemButton.name = _local3.toString();
                        this.item.push(this.itemButton);
                        this.state(this.itemIndex, true);
                        _local3++;
                    };
                } else {
                    if ((_arg1 is String)){
                        this.itemButton = new ItemButton(((this.convert(1) + " . ") + _arg1));
                        this.itemButton.name = "0";
                        this.item.push(this.itemButton);
                        this.state(this.itemIndex, true);
                    };
                };
            };
            this.itemTotal = this.item.length;
            this.pageTotal = Math.ceil((this.itemTotal / PAGE_SIZE));
            this.init();
            this.open(this.pageIndex);
        }
        public function set player(_arg1:Object):void{
            this._player = _arg1;
            this._player.addEventListener("event.play", this.playHandler);
        }
        private function playHandler(_arg1:Event):void{
            this.itemIndex = _arg1.target.index;
            this.state(this.itemIndex, true);
            this.jump(this.itemIndex);
        }
        private function clear():void{
            var _local2:DisplayObject;
            var _local1:int;
            while (_local1 < this.currentPage.length) {
                _local2 = (this.currentPage[_local1] as DisplayObject);
                removeChild(_local2);
                _local2 = null;
                _local1++;
            };
            this.currentPage = [];
        }
        private function open(_arg1:int):void{
            this.clear();
            var _local2:int = (_arg1 * PAGE_SIZE);
            var _local3:int = (_local2 + PAGE_SIZE);
            if (_local3 > (this.itemTotal - 1)){
                _local3 = this.itemTotal;
            };
            var _local4:int = _local2;
            while (_local4 < _local3) {
                this.item[_local4].x = 6;
                this.item[_local4].y = (6 + (Math.floor((_local4 - _local2)) * 18));
                addChild(this.item[_local4]);
                this.currentPage.push(this.item[_local4]);
                this.item[_local4].addEventListener(MouseEvent.CLICK, this.clickHandler);
                this.item[_local4].addEventListener(MouseEvent.MOUSE_OVER, this.overHandler);
                this.item[_local4].addEventListener(MouseEvent.MOUSE_OUT, this.outHandler);
                _local4++;
            };
            this.currentPageText.text = (((("第" + (_arg1 + 1)) + "/") + this.pageTotal) + "页");
        }
        private function clickHandler(_arg1:MouseEvent):void{
            this.itemIndex = int(_arg1.currentTarget.name);
            this.state(this.itemIndex, true);
            this._player.close();
            this._player.autoPlay = false;
            this._player.index = this.itemIndex;
            this._player.initPlay();
        }
        private function overHandler(_arg1:MouseEvent):void{
            _arg1.currentTarget.setColor(0xFF0000);
        }
        private function outHandler(_arg1:MouseEvent):void{
            this.state(this.itemIndex, true);
        }
        public function state(_arg1:int, _arg2:Boolean):void{
            this.itemIndex = _arg1;
            var _local3:int;
            while (_local3 < this.item.length) {
                if (_arg1 == _local3){
                    if (_arg2){
                        this.item[_local3].setColor(65382);
                        this.item[_local3].status = "down";
                    } else {
                        this.item[_local3].setColor(0xFF0000);
                    };
                } else {
                    this.item[_local3].setColor(268435455);
                    this.item[_local3].status = "up";
                };
                _local3++;
            };
        }
        private function convert(_arg1:int):String{
            if (_arg1 < 10){
                return (("0" + _arg1.toString()));
            };
            return (_arg1.toString());
        }
        private function init():void{
            this.pageTotalText = new Label();
            this.pageTotalText.setColor(0xFFFFFF);
            this.pageTotalText.x = 6;
            this.pageTotalText.y = 145;
            this.pageTotalText.text = (((((("共" + this.pageTotal) + "页") + "   ") + "每页") + PAGE_SIZE) + "首");
            addChild(this.pageTotalText);
            this.startButton = new Button();
            this.startButton.x = (this.pageTotalText.width + 12);
            this.startButton.y = this.pageTotalText.y;
            this.startButton.htmlText = "<a href=\"event:\">首页</a>";
            addChild(this.startButton);
            this.prevButton = new Button();
            this.prevButton.x = ((this.startButton.x + this.startButton.width) + 6);
            this.prevButton.y = this.startButton.y;
            this.prevButton.htmlText = "<a href=\"event:\">上一页</a>";
            addChild(this.prevButton);
            this.nextButton = new Button();
            this.nextButton.x = ((this.prevButton.x + this.prevButton.width) + 6);
            this.nextButton.y = this.startButton.y;
            this.nextButton.htmlText = "<a href=\"event:\">下一页</a>";
            addChild(this.nextButton);
            this.endButton = new Button();
            this.endButton.x = ((this.nextButton.x + this.nextButton.width) + 6);
            this.endButton.y = this.nextButton.y;
            this.endButton.htmlText = "<a href=\"event:\">尾页</a>";
            addChild(this.endButton);
            this.currentPageText = new Label();
            this.currentPageText.setColor(0xFFFFFF);
            this.currentPageText.x = ((this.endButton.x + this.endButton.width) + 6);
            this.currentPageText.y = this.pageTotalText.y;
            this.currentPageText.text = (("第" + (this.pageIndex + 1)) + "页");
            addChild(this.currentPageText);
            this.fengexian = new Label();
            this.fengexian.setColor(0xFFFFFF);
            this.fengexian.x = (this.pageTotalText.x - 5);
            this.fengexian.y = (this.pageTotalText.y - 14);
            this.fengexian.text = "---------------------------------------------------------------------------";
            addChild(this.fengexian);
            this.startButton.addEventListener(MouseEvent.CLICK, this.startHandler);
            this.nextButton.addEventListener(MouseEvent.CLICK, this.nextHandler);
            this.prevButton.addEventListener(MouseEvent.CLICK, this.prevHandler);
            this.endButton.addEventListener(MouseEvent.CLICK, this.endHandler);
        }
        private function startHandler(_arg1:MouseEvent):void{
            this.start();
        }
        private function nextHandler(_arg1:MouseEvent):void{
            this.next();
        }
        private function prevHandler(_arg1:MouseEvent):void{
            this.prev();
        }
        private function endHandler(_arg1:MouseEvent):void{
            this.end();
        }
        private function start():void{
            this.pageIndex = 0;
            this.open(this.pageIndex);
        }
        private function prev():void{
            if (this.pageIndex > 0){
                this.pageIndex--;
            };
            this.open(this.pageIndex);
        }
        private function next():void{
            if (this.pageIndex < (this.pageTotal - 1)){
                this.pageIndex++;
            };
            this.open(this.pageIndex);
        }
        private function end():void{
            this.pageIndex = (this.pageTotal - 1);
            this.open(this.pageIndex);
        }
        public function jump(_arg1:int):void{
            this.pageIndex = ArrayUtil.decoder(this.itemTotal, PAGE_SIZE, _arg1);
            this.open(this.pageIndex);
        }

    }
}//package com.ui 
