﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.vini123.spectrum {
    import flash.events.*;
    import flash.display.*;
    import flash.utils.*;
    import flash.filters.*;
    import flash.geom.*;
    import flash.media.*;

    public class RonSoundFX extends EventDispatcher {

        protected var _fxID:int;
        protected var _tw:int;
        protected var _th:int;
        protected var fxContainer:DisplayObjectContainer;
        protected var fxShape:Shape;
        protected var fxSprite:Sprite;
        protected var isStarted:Boolean;
        protected var mc:Number;
        protected var mf:Boolean;
        protected var md:Boolean;
        protected var mz:int = 1;
        protected var tl:Array;
        protected var cs:Number = 1;
        protected var cl:Array;
        protected var br:BlurFilter;
        protected var cm:ColorMatrixFilter;
        protected var bd:BitmapData;
        protected var bdbd:BitmapData;
        protected var rt:Rectangle;
        protected var pt:Point;
        protected var fn:Function;
        protected var ml:Array;
        protected var bn:int;
        protected var dy:Number;
        protected var dz:Number = 0;
        protected var listVal:Array;
        protected var listDot:Array;
        protected var listBar:Array;
        protected var list256:Array;
        protected var list512:Array;

        public function RonSoundFX(_arg1:DisplayObjectContainer, _arg2:int=600, _arg3:int=350, _arg4:int=0){
            this.fxContainer = _arg1;
            this.fxShape = new Shape();
            this.fxContainer.addChild(this.fxShape);
            this.fxSprite = new Sprite();
            this.fxContainer.addChild(this.fxSprite);
            this._tw = _arg2;
            this._th = _arg3;
            this._fxID = _arg4;
            this.fxContainer.scrollRect = new Rectangle(0, 0, this._tw, this._th);
            this.fxInit();
            super();
        }
        public function start():void{
            this.stop();
            this.isStarted = true;
            this.dz = 0;
            this.bn = (this.tw * 0.125);
            if (this.bn > 0x0200){
                this.bn = 0x0200;
            };
            this.dy = (this.th * 0.008);
            this.listVal = this.zero(this.bn);
            this.listDot = this.zero(this.bn);
            this.listBar = this.zero(this.bn);
            this.list256 = this.zero(0x0100);
            this.list512 = this.zero(0x0200);
            this.rt = new Rectangle(0, 0, this.tw, this.th);
            this.bd = new BitmapData(this.tw, this.th, true, 0);
            while (this.fxSprite.numChildren) {
                this.fxSprite.removeChildAt(0);
            };
            this.fxSprite.addChild(new Bitmap(this.bd));
            this.mc = 10808076;
            this.mf = true;
            this.md = true;
            this.fn = this.ml[this.fxID];
            this.fxContainer.addEventListener(Event.ENTER_FRAME, this.onEnterFrameHandler);
        }
        public function stop():void{
            this.isStarted = false;
            if (!this.fxContainer.hasEventListener(Event.ENTER_FRAME)){
                return;
            };
            this.cs = Math.floor((this.cl.length * Math.random()));
            this.fxContainer.removeEventListener(Event.ENTER_FRAME, this.onEnterFrameHandler);
            this.fxShape.graphics.clear();
            this.clearF();
        }
        protected function onEnterFrameHandler(_arg1:Event):void{
            if (this.fn != null){
                this.fn();
            };
        }
        protected function fxInit():void{
            this.tl = [1, 2, 4];
            this.pt = new Point(0, 0);
            this.cm = new ColorMatrixFilter([1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0.9, 0]);
            this.br = new BlurFilter(8, 8, 2);
            this.cl = this.gCL();
            this.ml = this.gML();
        }
        protected function rC():void{
            var _local1:* = Math.random();
            if (_local1 > 0.99){
                this.mz = (this.mz * -1);
                if (_local1 > 0.999){
                    this.tl.push(this.tl.shift());
                };
            };
            var _local2:* = Math.round(((this.mz * _local1) * 5));
            this.cs = (this.cs + _local2);
            if (this.cs < 0){
                this.cs = (this.cl.length - 1);
            } else {
                if (this.cs >= this.cl.length){
                    this.cs = 0;
                };
            };
            this.mc = this.cl[this.cs];
        }
        protected function zero(_arg1:int):Array{
            var _local2:Array = [];
            var _local3:int;
            while (_local3 < _arg1) {
                _local2.push(0);
                _local3++;
            };
            return (_local2);
        }
        protected function gML():Array{
            return ([this.m11, this.m02, this.m03, this.m04, this.m05, this.m06, this.m07, this.m08, this.m09, this.m10]);
        }
        protected function applyDisplace(_arg1:BitmapData):void{
            this.bdbd = _arg1.clone();
            var _local2:* = new DisplacementMapFilter(this.bdbd, this.pt, this.tl[0], this.tl[1], 10, 10, "clamp");
            _arg1.applyFilter(this.bdbd, _arg1.rect, this.pt, _local2);
        }
        protected function gCL():Array{
            var _local1:Array = [];
            var _local2:Array = [];
            var _local3:Array = [];
            var _local4:Array = [];
            var _local5:Array = [];
            var _local6:Array = [];
            var _local7:int;
            while (_local7 < 0xFF) {
                _local1.push((0xFF0000 + (_local7 * 0x0100)));
                _local2.push((((0xFF - _local7) * 65536) + 0xFF00));
                _local3.push((0xFF00 + _local7));
                _local4.push((((0xFF - _local7) * 0x0100) + 0xFF));
                _local5.push((0xFF + (_local7 * 65536)));
                _local6.push(((0xFF - _local7) + 0xFF0000));
                _local7 = (_local7 + 3);
            };
            var _local8:Array = [];
            _local8 = [].concat(_local1).concat(_local2).concat(_local3).concat(_local4).concat(_local5).concat(_local6);
            return (_local8);
        }
        protected function gb(_arg1:Boolean=false):ByteArray{
            var _local2:ByteArray = new ByteArray();
            if (SoundMixer.areSoundsInaccessible()){
                this.stop();
            } else {
                try {
                    SoundMixer.computeSpectrum(_local2, _arg1);
                } catch(e:Error) {
                };
            };
            return (_local2);
        }
        protected function clearF():void{
            if (this.bd){
                this.bd.fillRect(this.bd.rect, 0);
            };
        }
        protected function sF(_arg1:Boolean=true):void{
            if (this.mf){
                this.bd.draw(this.fxShape);
                if (this.md){
                    this.rC();
                    if (_arg1){
                        this.applyDisplace(this.bd);
                    } else {
                        this.bd.applyFilter(this.bd, this.rt, this.pt, this.cm);
                    };
                } else {
                    this.bd.applyFilter(this.bd, this.rt, this.pt, this.cm);
                };
                this.bd.applyFilter(this.bd, this.rt, this.pt, this.br);
            };
        }
        protected function lr(_arg1:ByteArray, _arg2:Boolean=false):ByteArray{
            var _local3:ByteArray;
            var _local4:Number = NaN;
            var _local5:Number = NaN;
            var _local6:Number = NaN;
            var _local7:* = new ByteArray();
            _arg1.position = 0;
            if (_arg1.bytesAvailable){
                _local3 = new ByteArray();
                _arg1.position = 0x0400;
                _arg1.readBytes(_local3);
                _arg1.position = 0;
                while (_local3.bytesAvailable) {
                    _local4 = _arg1.readFloat();
                    _local5 = _local3.readFloat();
                    if (((_arg2) || ((((_local4 > 0)) && ((_local5 > 0)))))){
                        _local6 = ((_local4 > _local5)) ? _local4 : _local5;
                    } else {
                        if ((((_local4 < 0)) && ((_local5 < 0)))){
                            _local6 = ((_local4 < _local5)) ? _local4 : _local5;
                        } else {
                            _local6 = ((_local4 + _local5) * 0.5);
                        };
                    };
                    _local7.writeFloat(_local6);
                };
                _local7.position = 0;
            };
            return (_local7);
        }
        protected function m11():void{
            var _local1:Number = 0;
            var _local2:* = this.lr(this.gb(true), true);
            var _local3:* = (this.tw * 0.00390625);
            var _local4:* = (this.th * 0.666);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.beginFill(this.mc);
            var _local5:* = (this.tw / this.bn);
            var _local6:* = (Math.floor(((252 / this.bn) - 1)) * 4);
            var _local7:int;
            while ((((_local7 < this.bn)) && (_local2.bytesAvailable))) {
                _local1 = (_local4 * _local2.readFloat());
                if (_local6){
                    _local2.position = (_local2.position + _local6);
                };
                this.listVal[_local7] = (this.listVal[_local7] * 1.1);
                this.listDot[_local7] = (this.listDot[_local7] - this.listVal[_local7]);
                if (this.listDot[_local7] < _local1){
                    this.listVal[_local7] = (this.dy * 0.5);
                    this.listDot[_local7] = _local1;
                };
                this.listBar[_local7] = (this.listBar[_local7] - (this.listVal[_local7] + 2));
                if (this.listBar[_local7] < _local1){
                    this.listBar[_local7] = _local1;
                };
                this.fxShape.graphics.drawRect((_local5 * _local7), this.th, (_local5 - 1), -(this.listBar[_local7]));
                this.fxShape.graphics.drawRect((_local5 * _local7), ((this.th - this.listDot[_local7]) - 1), (_local5 - 1), 1);
                _local7++;
            };
            this.fxShape.graphics.endFill();
            this.sF(false);
        }
        protected function m02():void{
            var _local1:Number = NaN;
            var _local2:int;
            var _local3:* = this.lr(this.gb());
            var _local4:* = (this.th * 0.5);
            var _local5:* = (this.tw * 0.00390625);
            var _local6:* = (_local4 * 0.8);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.lineStyle(1, this.mc);
            if (_local3.bytesAvailable){
                _local1 = (_local6 * _local3.readFloat());
                this.fxShape.graphics.moveTo(0, (_local4 + _local1));
                _local2 = 1;
                while (_local2 < 0x0100) {
                    _local1 = (_local6 * _local3.readFloat());
                    this.fxShape.graphics.lineTo((_local2 * _local5), (_local4 + _local1));
                    _local2++;
                };
            };
            this.sF(false);
        }
        protected function m03():void{
            var _local1:int;
            var _local2:Number = NaN;
            var _local3:* = this.gb(true);
            var _local4:* = (this.tw * 0.00195313);
            var _local5:* = (this.th * 0.666);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.beginFill(this.mc);
            this.fxShape.graphics.moveTo((this.tw * 0.5), this.th);
            if (_local3.bytesAvailable){
                _local1 = 0xFF;
                while (_local1 > 0) {
                    _local2 = (_local5 * _local3.readFloat());
                    this.fxShape.graphics.lineTo((_local1 * _local4), (this.th - _local2));
                    _local1--;
                };
                this.fxShape.graphics.lineTo(0, this.th);
                this.fxShape.graphics.moveTo((this.tw * 0.5), this.th);
                _local1 = 0x0100;
                while (_local1 < 0x0200) {
                    _local2 = (_local5 * _local3.readFloat());
                    this.fxShape.graphics.lineTo((_local1 * _local4), (this.th - _local2));
                    _local1++;
                };
            };
            this.fxShape.graphics.lineTo(this.tw, this.th);
            this.fxShape.graphics.endFill();
            this.sF(false);
        }
        protected function m04():void{
            var _local1:Number = NaN;
            var _local2:* = this.lr(this.gb(true), true);
            var _local3:* = (this.tw * 0.00390625);
            var _local4:* = (this.th * 0.666);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.lineStyle(1, this.mc);
            this.fxShape.graphics.beginFill(this.mc);
            this.fxShape.graphics.moveTo(0, this.th);
            var _local5 = 1;
            while ((((_local5 < 0x0100)) && (_local2.bytesAvailable))) {
                _local1 = (_local4 * _local2.readFloat());
                this.list256[_local5] = (this.list256[_local5] - (this.dy * 2));
                if (this.list256[_local5] < _local1){
                    this.list256[_local5] = _local1;
                };
                this.fxShape.graphics.lineTo((_local5 * _local3), (this.th - this.list256[_local5]));
                _local5++;
            };
            this.fxShape.graphics.lineTo(this.tw, this.th);
            this.fxShape.graphics.endFill();
            this.sF(false);
        }
        protected function m05():void{
            var _local1:Number = NaN;
            var _local2:* = this.gb(true);
            var _local3:* = (this.th * 0.5);
            var _local4:* = (this.tw * 0.00390625);
            var _local5:* = (this.th * 0.4);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.beginFill(this.mc);
            this.fxShape.graphics.moveTo(0, _local3);
            var _local6:int;
            while (_local2.bytesAvailable) {
                _local1 = (_local5 * _local2.readFloat());
                this.list512[_local6] = (this.list512[_local6] - (this.dy * 2));
                if (this.list512[_local6] < _local1){
                    this.list512[_local6] = _local1;
                };
                if (_local6 >= 0x0100){
                    if (_local6 == 0x0100){
                        this.fxShape.graphics.lineTo(this.tw, _local3);
                        this.fxShape.graphics.lineTo(0, _local3);
                    };
                    this.fxShape.graphics.lineTo(((_local6 - 0x0100) * _local4), (_local3 - this.list512[_local6]));
                } else {
                    this.fxShape.graphics.lineTo((_local6 * _local4), (_local3 + this.list512[_local6]));
                };
                _local6++;
            };
            this.fxShape.graphics.lineTo(this.tw, _local3);
            this.fxShape.graphics.lineTo(0, _local3);
            this.sF(false);
        }
        protected function m06():void{
            var _local1:Number = NaN;
            var _local2:int;
            var _local3:Number = NaN;
            var _local4:Number = NaN;
            var _local5:Number = NaN;
            var _local6:* = this.lr(this.gb(true), true);
            var _local7:* = (this.tw * 0.5);
            var _local8:* = (this.th * 0.5);
            var _local9:* = (this.th * 0.3);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.lineStyle(5, this.mc);
            this.fxShape.graphics.moveTo(_local7, _local8);
            var _local10:int;
            while (_local6.bytesAvailable) {
                _local1 = ((_local9 * _local6.readFloat()) + 5);
                this.list256[_local10] = (this.list256[_local10] - this.dy);
                if (this.list256[_local10] < _local1){
                    this.list256[_local10] = _local1;
                    this.list512[_local10] = (Math.random() * 360);
                };
                _local1 = this.list256[_local10];
                _local2 = this.list512[_local10];
                _local3 = (_local2 * (Math.PI / 180));
                _local4 = ((_local1 * Math.cos(_local3)) + _local7);
                _local5 = ((_local1 * Math.sin(_local3)) + _local8);
                this.fxShape.graphics.moveTo(_local7, _local8);
                this.fxShape.graphics.lineTo(_local4, _local5);
                _local10++;
            };
            this.sF(false);
        }
        protected function m07():void{
            var _local5:*;
            var _local6:*;
            var _local7:*;
            var _local1:int;
            var _local2:* = this.lr(this.gb(true), true);
            this.fxShape.graphics.clear();
            var _local3 = 20;
            var _local4:int;
            while ((((_local4 < 0x0100)) && (_local2.bytesAvailable))) {
                if (this.list256[_local4] < 1){
                    this.list256[_local4] = 1;
                    _local5 = (_local3 * _local2.readFloat());
                    _local1 = (_local3 * _local2.readFloat());
                    this.list256[(_local4 + 1)] = _local5;
                    this.list256[(_local4 + 2)] = (((this.tw - (2 * _local3)) * Math.random()) + _local3);
                    _local1 = (_local1 * 0.5);
                    if (_local1 < 3){
                        _local1 = 3;
                    };
                    this.list256[(_local4 + 3)] = _local1;
                } else {
                    _local5 = this.list256;
                    _local7 = (this.list256[(_local4 + 1)] - 1);
                    _local5[(_local4 + 1)] = _local7;
                    this.list256[_local4] = (this.list256[_local4] + this.list256[(_local4 + 1)]);
                    if (this.list256[(_local4 + 3)] > 3){
                        this.list256[(_local4 + 3)] = (this.list256[(_local4 + 3)] - 0.5);
                    };
                };
                this.fxShape.graphics.beginFill(this.mc);
                this.fxShape.graphics.drawCircle(this.list256[(_local4 + 2)], (this.th - this.list256[_local4]), this.list256[(_local4 + 3)]);
                this.fxShape.graphics.endFill();
                _local4 = (_local4 + 8);
            };
            this.sF();
        }
        protected function m08():void{
            var _local1:Number = NaN;
            var _local2:* = this.lr(this.gb(true), true);
            var _local3 = 10;
            this.fxShape.graphics.clear();
            var _local4:int;
            while ((((_local4 < 0x0100)) && (_local2.bytesAvailable))) {
                _local1 = (_local3 * _local2.readFloat());
                if (this.list256[_local4] < 1){
                    this.list256[(_local4 + 1)] = (((this.tw - (2 * _local3)) * Math.random()) + _local3);
                    this.list256[(_local4 + 2)] = (((this.th - (2 * _local3)) * Math.random()) + _local3);
                    this.list256[(_local4 + 3)] = false;
                };
                if (this.list256[_local4] < _local1){
                    this.list256[_local4] = _local1;
                };
                this.list256[_local4] = (this.list256[_local4] - 0.5);
                if ((((((_local1 > 8)) && (_local4))) || (this.list256[(_local4 + 3)]))){
                    if (this.list256[(_local4 + 3)]){
                        if (this.list256[(_local4 + 4)] > 0){
                            this.list256[(_local4 + 4)] = (this.list256[(_local4 + 4)] - 0.05);
                        } else {
                            this.list256[(_local4 + 3)] = false;
                        };
                    } else {
                        this.list256[(_local4 + 4)] = 1;
                        this.list256[(_local4 + 3)] = true;
                    };
                    this.fxShape.graphics.lineStyle(1, this.mc, this.list256[(_local4 + 4)]);
                    this.fxShape.graphics.lineTo(this.list256[(_local4 + 1)], this.list256[(_local4 + 2)]);
                };
                this.fxShape.graphics.beginFill(this.mc);
                this.fxShape.graphics.drawCircle(this.list256[(_local4 + 1)], this.list256[(_local4 + 2)], this.list256[_local4]);
                this.fxShape.graphics.moveTo(this.list256[(_local4 + 1)], this.list256[(_local4 + 2)]);
                this.fxShape.graphics.endFill();
                _local4 = (_local4 + 8);
            };
            this.sF(false);
        }
        protected function m09():void{
            var _local1:Number = NaN;
            var _local2:Point;
            var _local3:Number = NaN;
            var _local4:int;
            var _local5:Number = NaN;
            var _local6:Number = NaN;
            var _local7:Number = NaN;
            var _local8:* = this.gb(true);
            var _local9:* = (this.tw * 0.5);
            var _local10:* = (this.th * 0.5);
            this.fxShape.graphics.clear();
            this.fxShape.graphics.lineStyle(1, this.mc);
            var _local11:* = (this.th * 0.3);
            var _local12:Array = [];
            var _local13:Number = 0;
            var _local14:Number = 0;
            var _local15 = 1;
            while (_local8.bytesAvailable) {
                _local3 = _local8.readFloat();
                if (_local3 > 0){
                    _local1 = ((_local3 * _local11) + 5);
                    _local13 = (_local13 + _local1);
                    _local14 = (_local13 / _local15);
                    _local12.push((_local1 - _local14));
                    _local15++;
                };
            };
            var _local16:int;
            var _local17:* = _local12.length;
            var _local18:int;
            while (_local16 < _local17) {
                _local1 = (Math.abs(((_local12[_local16] - _local14) * 0.5)) + _local14);
                this.list512[_local16] = (this.list512[_local16] - this.dy);
                if (this.list512[_local16] < _local1){
                    this.list512[_local16] = _local1;
                };
                _local1 = this.list512[_local16];
                _local4 = (Math.round(((_local16 * 360) / _local17)) + this.dz);
                _local5 = (_local4 * (Math.PI / 180));
                _local6 = (Math.round((_local1 * Math.cos(_local5))) + _local9);
                _local7 = (Math.round((_local1 * Math.sin(_local5))) + _local10);
                if (_local16 == 0){
                    this.fxShape.graphics.moveTo(_local9, _local10);
                    _local2 = new Point(_local6, _local7);
                };
                this.fxShape.graphics.lineTo(_local6, _local7);
                if ((_local4 - _local18) > 8){
                    this.fxShape.graphics.lineTo(_local9, _local10);
                    this.fxShape.graphics.moveTo(_local6, _local7);
                    _local18 = _local4;
                };
                _local16++;
            };
            if (_local2){
                this.fxShape.graphics.lineTo(_local2.x, _local2.y);
            };
            this.dz++;
            this.sF(false);
        }
        protected function m10():void{
            var _local5:*;
            var _local6:*;
            var _local7:*;
            var _local1:Number = NaN;
            var _local2:* = this.lr(this.gb(true), true);
            var _local3 = 20;
            this.fxShape.graphics.clear();
            this.fxShape.graphics.lineStyle(1, this.mc);
            var _local4:int;
            while ((((_local4 < 0x0100)) && (_local2.bytesAvailable))) {
                _local1 = (_local3 * _local2.readFloat());
                if (this.list256[_local4] < 1){
                    this.list256[(_local4 + 1)] = (((this.tw - (2 * _local3)) * Math.random()) + _local3);
                    this.list256[(_local4 + 2)] = (((this.th - (2 * _local3)) * Math.random()) + _local3);
                };
                if (this.list256[_local4] < _local1){
                    this.list256[_local4] = _local1;
                };
                _local5 = this.list256;
                _local6 = _local4;
                _local7 = (this.list256[_local4] - 1);
                _local5[_local6] = _local7;
                this.fxShape.graphics.drawCircle(this.list256[(_local4 + 1)], this.list256[(_local4 + 2)], this.list256[_local4]);
                _local4 = (_local4 + 8);
            };
            this.sF();
        }
        public function get fxID():int{
            return (this._fxID);
        }
        public function set fxID(_arg1:int):void{
            this._fxID = _arg1;
            this.start();
        }
        public function get tw():int{
            return (this._tw);
        }
        public function set tw(_arg1:int):void{
            this._tw = _arg1;
            this.sizeFX();
        }
        protected function sizeFX():void{
            this.fxContainer.scrollRect = new Rectangle(0, 0, this._tw, this._th);
            if (this.isStarted){
                this.start();
            };
        }
        public function get th():int{
            return (this._th);
        }
        public function set th(_arg1:int):void{
            this._th = _arg1;
            this.sizeFX();
        }

    }
}//package com.vini123.spectrum 
