﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package com.vini123.spectrum {
    import flash.events.*;
    import flash.display.*;
    import flash.utils.*;
    import flash.text.*;
    import flash.filters.*;
    import flash.geom.*;
    import flash.media.*;

    public class Spectrum extends Sprite {

        public var txt:TextField;//instance name
        private var fx:Sprite;
        private var sfx:RonSoundFX;
        private var sound:Sound;
        private var channel:SoundChannel;
        public var ctm:ColorTransform;
        public var incY:int;
        public var bf:BlurFilter;
        public var canvas:BitmapData;
        public var sw:int;
        public var sh:int;
        public var bmp:Bitmap;
        public var transformMatrix:Matrix;
        public var dummy:BitmapData;
        public var incX:int;
        public var mtx:Matrix;
        private var _root;
        private var myTimer:Timer;

        public function Spectrum(){
            this.myTimer = new Timer(5432, 0);
            super();
            this.txt.mouseEnabled = false;
            this.initializeUI();
            this.myTimer.addEventListener(TimerEvent.TIMER, this.timerHandler);
            this.addEventListener(MouseEvent.CLICK, this.timerHandler);
        }
        private function timerHandler(_arg1=null):void{
            var _local2:int = Math.floor((Math.random() * 10));
            this.changeType(_local2);
        }
        private function initializeUI():void{
            this.fx = new Sprite();
            addChild(this.fx);
        }
        public function start():void{
            this.txt.text = "";
            if (this.sfx){
                this.sfx.start();
            };
            this.myTimer.start();
        }
        public function stop():void{
            if (this.sfx){
                this.sfx.stop();
            };
            this.myTimer.stop();
        }
        public function creatSoundFx(_arg1:Number, _arg2:Number){
            this.sfx = new RonSoundFX(this.fx, _arg1, _arg2, 0);
        }
        public function changeType(_arg1:int):void{
            if (((((this.sfx) && ((_arg1 < 10)))) && ((_arg1 > -1)))){
                this.sfx.fxID = _arg1;
            };
        }

    }
}//package com.vini123.spectrum 
