﻿//Created by Action Script Viewer - http://www.buraks.com/asv
package caurina.transitions {

    public class TweenListObj {

        public var scope:Object;
        public var properties:Object;
        public var timeStart:Number;
        public var timeComplete:Number;
        public var useFrames:Boolean;
        public var transition:Function;
        public var transitionParams:Object;
        public var onStart:Function;
        public var onUpdate:Function;
        public var onComplete:Function;
        public var onOverwrite:Function;
        public var onError:Function;
        public var onStartParams:Array;
        public var onUpdateParams:Array;
        public var onCompleteParams:Array;
        public var onOverwriteParams:Array;
        public var onStartScope:Object;
        public var onUpdateScope:Object;
        public var onCompleteScope:Object;
        public var onOverwriteScope:Object;
        public var onErrorScope:Object;
        public var rounded:Boolean;
        public var isPaused:Boolean;
        public var timePaused:Number;
        public var isCaller:Boolean;
        public var count:Number;
        public var timesCalled:Number;
        public var waitFrames:Boolean;
        public var skipUpdates:Number;
        public var updatesSkipped:Number;
        public var hasStarted:Boolean;

        public function TweenListObj(_arg1:Object, _arg2:Number, _arg3:Number, _arg4:Boolean, _arg5:Function, _arg6:Object){
            this.scope = _arg1;
            this.timeStart = _arg2;
            this.timeComplete = _arg3;
            this.useFrames = _arg4;
            this.transition = _arg5;
            this.transitionParams = _arg6;
            this.properties = new Object();
            this.isPaused = false;
            this.timePaused = undefined;
            this.isCaller = false;
            this.updatesSkipped = 0;
            this.timesCalled = 0;
            this.skipUpdates = 0;
            this.hasStarted = false;
        }
        public static function makePropertiesChain(_arg1:Object):Object{
            var _local3:Object;
            var _local4:Object;
            var _local5:Object;
            var _local6:Number;
            var _local7:Number;
            var _local8:Number;
            var _local2:Object = _arg1.base;
            if (_local2){
                _local3 = {};
                if ((_local2 is Array)){
                    _local4 = [];
                    _local8 = 0;
                    while (_local8 < _local2.length) {
                        _local4.push(_local2[_local8]);
                        _local8++;
                    };
                } else {
                    _local4 = [_local2];
                };
                _local4.push(_arg1);
                _local6 = _local4.length;
                _local7 = 0;
                while (_local7 < _local6) {
                    if (_local4[_local7]["base"]){
                        _local5 = AuxFunctions.concatObjects(makePropertiesChain(_local4[_local7]["base"]), _local4[_local7]);
                    } else {
                        _local5 = _local4[_local7];
                    };
                    _local3 = AuxFunctions.concatObjects(_local3, _local5);
                    _local7++;
                };
                if (_local3["base"]){
                    delete _local3["base"];
                };
                return (_local3);
            };
            return (_arg1);
        }

        public function clone(_arg1:Boolean):TweenListObj{
            var _local3:String;
            var _local2:TweenListObj = new TweenListObj(this.scope, this.timeStart, this.timeComplete, this.useFrames, this.transition, this.transitionParams);
            _local2.properties = new Array();
            for (_local3 in this.properties) {
                _local2.properties[_local3] = this.properties[_local3].clone();
            };
            _local2.skipUpdates = this.skipUpdates;
            _local2.updatesSkipped = this.updatesSkipped;
            if (!_arg1){
                _local2.onStart = this.onStart;
                _local2.onUpdate = this.onUpdate;
                _local2.onComplete = this.onComplete;
                _local2.onOverwrite = this.onOverwrite;
                _local2.onError = this.onError;
                _local2.onStartParams = this.onStartParams;
                _local2.onUpdateParams = this.onUpdateParams;
                _local2.onCompleteParams = this.onCompleteParams;
                _local2.onOverwriteParams = this.onOverwriteParams;
                _local2.onStartScope = this.onStartScope;
                _local2.onUpdateScope = this.onUpdateScope;
                _local2.onCompleteScope = this.onCompleteScope;
                _local2.onOverwriteScope = this.onOverwriteScope;
                _local2.onErrorScope = this.onErrorScope;
            };
            _local2.rounded = this.rounded;
            _local2.isPaused = this.isPaused;
            _local2.timePaused = this.timePaused;
            _local2.isCaller = this.isCaller;
            _local2.count = this.count;
            _local2.timesCalled = this.timesCalled;
            _local2.waitFrames = this.waitFrames;
            _local2.hasStarted = this.hasStarted;
            return (_local2);
        }
        public function toString():String{
            var _local3:String;
            var _local1 = "\n[TweenListObj ";
            _local1 = (_local1 + ("scope:" + String(this.scope)));
            _local1 = (_local1 + ", properties:");
            var _local2:Boolean;
            for (_local3 in this.properties) {
                if (!_local2){
                    _local1 = (_local1 + ",");
                };
                _local1 = (_local1 + ("[name:" + this.properties[_local3].name));
                _local1 = (_local1 + (",valueStart:" + this.properties[_local3].valueStart));
                _local1 = (_local1 + (",valueComplete:" + this.properties[_local3].valueComplete));
                _local1 = (_local1 + "]");
                _local2 = false;
            };
            _local1 = (_local1 + (", timeStart:" + String(this.timeStart)));
            _local1 = (_local1 + (", timeComplete:" + String(this.timeComplete)));
            _local1 = (_local1 + (", useFrames:" + String(this.useFrames)));
            _local1 = (_local1 + (", transition:" + String(this.transition)));
            _local1 = (_local1 + (", transitionParams:" + String(this.transitionParams)));
            if (this.skipUpdates){
                _local1 = (_local1 + (", skipUpdates:" + String(this.skipUpdates)));
            };
            if (this.updatesSkipped){
                _local1 = (_local1 + (", updatesSkipped:" + String(this.updatesSkipped)));
            };
            if (Boolean(this.onStart)){
                _local1 = (_local1 + (", onStart:" + String(this.onStart)));
            };
            if (Boolean(this.onUpdate)){
                _local1 = (_local1 + (", onUpdate:" + String(this.onUpdate)));
            };
            if (Boolean(this.onComplete)){
                _local1 = (_local1 + (", onComplete:" + String(this.onComplete)));
            };
            if (Boolean(this.onOverwrite)){
                _local1 = (_local1 + (", onOverwrite:" + String(this.onOverwrite)));
            };
            if (Boolean(this.onError)){
                _local1 = (_local1 + (", onError:" + String(this.onError)));
            };
            if (this.onStartParams){
                _local1 = (_local1 + (", onStartParams:" + String(this.onStartParams)));
            };
            if (this.onUpdateParams){
                _local1 = (_local1 + (", onUpdateParams:" + String(this.onUpdateParams)));
            };
            if (this.onCompleteParams){
                _local1 = (_local1 + (", onCompleteParams:" + String(this.onCompleteParams)));
            };
            if (this.onOverwriteParams){
                _local1 = (_local1 + (", onOverwriteParams:" + String(this.onOverwriteParams)));
            };
            if (this.onStartScope){
                _local1 = (_local1 + (", onStartScope:" + String(this.onStartScope)));
            };
            if (this.onUpdateScope){
                _local1 = (_local1 + (", onUpdateScope:" + String(this.onUpdateScope)));
            };
            if (this.onCompleteScope){
                _local1 = (_local1 + (", onCompleteScope:" + String(this.onCompleteScope)));
            };
            if (this.onOverwriteScope){
                _local1 = (_local1 + (", onOverwriteScope:" + String(this.onOverwriteScope)));
            };
            if (this.onErrorScope){
                _local1 = (_local1 + (", onErrorScope:" + String(this.onErrorScope)));
            };
            if (this.rounded){
                _local1 = (_local1 + (", rounded:" + String(this.rounded)));
            };
            if (this.isPaused){
                _local1 = (_local1 + (", isPaused:" + String(this.isPaused)));
            };
            if (this.timePaused){
                _local1 = (_local1 + (", timePaused:" + String(this.timePaused)));
            };
            if (this.isCaller){
                _local1 = (_local1 + (", isCaller:" + String(this.isCaller)));
            };
            if (this.count){
                _local1 = (_local1 + (", count:" + String(this.count)));
            };
            if (this.timesCalled){
                _local1 = (_local1 + (", timesCalled:" + String(this.timesCalled)));
            };
            if (this.waitFrames){
                _local1 = (_local1 + (", waitFrames:" + String(this.waitFrames)));
            };
            if (this.hasStarted){
                _local1 = (_local1 + (", hasStarted:" + String(this.hasStarted)));
            };
            _local1 = (_local1 + "]\n");
            return (_local1);
        }

    }
}//package caurina.transitions 
